#include <stdio.h>
#include <stdlib.h>
#include <string.h>




static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}

static unsigned long get_dword(unsigned char *p){
	return (p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24));
}




static char flag_tbl[256][8];

static void make_flag_tbl(void){
	int k, n, m;
	int c;
	for(n = 0; 256 > n; ++n){
		c = -1;
		flag_tbl[n][0] = -1;
		m = n;
		for(k = 0; 8 > k; ++k){
			if(0 != (m & 1)){
				c += 1;
				flag_tbl[n][c] = 0;
			}
			else{
				if((0 > c)  || (0 == flag_tbl[n][c])){
					c += 1;
					flag_tbl[n][c] = 0;
				}
				flag_tbl[n][c] += 1;
			}
			m >>= 1;
		}
		if(7 > c){
			c += 1;
			flag_tbl[n][c] = -1;
		}
	}
}



static int expand(unsigned char *dest, long dest_size, unsigned char *src, long src_size){
	long ofs, d_ofs, f_ofs;

	f_ofs = 4;
	ofs = (get_word(src + 2) + 4);
	d_ofs = 0;

	while(ofs < src_size){
		char *flag;
		int flag_count;

		flag = flag_tbl[src[f_ofs]];
		f_ofs += 1;

		for(flag_count = 0; 8 > flag_count; ++flag_count){
			long t_ofs, t_len, t;

			if(src_size <= ofs){
				break;
			}

			t_len = flag[flag_count];
			if(0 > t_len){
				break;
			}

			if(0 < t_len){
				memcpy((dest + d_ofs), (src + ofs), t_len);
				d_ofs += t_len;
				ofs += t_len;
				continue;
			}

			t_ofs = (src[ofs] + 1);
			t_len = (src[ofs + 1] + 3);
			ofs += 2;

			t = t_ofs;
			t_ofs = (d_ofs - t_ofs);
			while(0 < t_len){
				if(t_len < t){
					t = t_len;
				}
				memcpy((dest + d_ofs), (dest + t_ofs), t);
				d_ofs += t;
				t_len -= t;
				t += t;
			}
		}
	}

	return d_ofs;
}






int main(int argc, char *argv[]){
	int err = 1;
	FILE *fp = NULL;
	char *t_buf = NULL;
	char *e_buf = NULL;
	char *ofs_tbl = NULL;


	make_flag_tbl();


	if(2 > argc){
		puts("gdm_exp.exe [infile]\n");
		exit(0);
	}


	t_buf = malloc(0x10000);
	if(NULL == t_buf){
		puts("sł\n");
		goto _end;
	}
	e_buf = malloc(0x10000);
	if(NULL == e_buf){
		puts("sł\n");
		goto _end;
	}


	fp = fopen(argv[1], "rb");
	if(NULL == fp){
		printf("%s ݂܂\n", argv[1]);
		goto _end;
	}


	{
		int t;
		ofs_tbl = calloc(1, 0x400);
		if(NULL == ofs_tbl){
			puts("sł\n");
			goto _end;
		}
		fseek(fp, 0, SEEK_SET);
		fread(t_buf, 1, 4, fp);
		t = get_word(t_buf);
		fread((t_buf + 4), 1, t, fp);
		t = expand(ofs_tbl, 0x400, t_buf, (t + 4));
	}


	{
		int k;
		long base;
		long ofs, size;
		long t_size;
		char t_name[32];
		char *t;
		FILE *fo;

		base = (get_word(t_buf) + 4);
		k = 0;
		while(1){
			ofs = get_dword(ofs_tbl + (k * 4));
			k += 1;
			size = get_dword(ofs_tbl + (k * 4));
			if(0 == size){
				break;
			}
			size -= ofs;
			fseek(fp, (base + ofs), SEEK_SET);
			fread(t_buf, 1, size, fp);

			if((0 == memcmp(t_buf, "hcg4", 4)) || (0 == memcmp(t_buf, "CCG4", 4))){
				t = t_buf;
			}
			else{
				t = e_buf;
				size = expand(e_buf, 0x10000, t_buf, size);
			}

			sprintf(t_name, "%03d.DAT", (k - 1));
			fo = fopen(t_name, "wb");
			fwrite(t, 1, size, fo);
			fclose(fo);
		}
	}

	err = 0;
_end:
	free(ofs_tbl);
	if(NULL != fp){
		fclose(fp);
	}
	free(e_buf);
	free(t_buf);
	exit(err);
}
